﻿package {
	import fl.controls.*;
	import flash.events.*;
	import flash.net.*;
	import flash.utils.*;
	import flash.display.*;
	import flash.text.*;
	import org.shokai.net.xmlsocket.command.*;
	import com.hurlant.util.Base64;
	
	public class Base64XMLSocketTest extends Sprite {
		private var commander:Commander;
		
		public function Base64XMLSocketTest() {
			// UI config
			stage.scaleMode = StageScaleMode.EXACT_FIT; // 伸縮する
			// stage.scaleMode = StageScaleMode.NO_SCALE; // 伸縮しない
			stage.align = StageAlign.TOP_LEFT; // 左上から
			buttonConnect.addEventListener(MouseEvent.CLICK, cmd_connect); // 接続ボタン
			buttonSend.addEventListener(MouseEvent.CLICK, cmd_send); // 送信ボタン
			
			// commander config
			commander = new Commander();
			commander.addEventListener(Event.CONNECT, cmd_onConnect); // 接続成功イベント
			commander.addEventListener(CommandEvent.ON_COMMAND, cmd_onRecv); // データ受信イベント
			commander.addEventListener(IOErrorEvent.IO_ERROR, cmd_ioError); // エラー
			commander.addEventListener(SecurityErrorEvent.SECURITY_ERROR, cmd_securityError); // エラー2
		}
		
		
		public function cmd_connect(e:Event) {
			commander.connect(textInputAddr.text, new int(textInputPort.text)); // 接続
		}
		
		public function cmd_send(e:Event){
			if(commander.connected){ // 接続先があれば
				var cmd:Command = new Command();
				cmd.name = textInputCmdName.text;
				cmd.value = Base64.encode(textInputCmdValue.text);
				commander.sendCommand(cmd); // コマンド送信
				write("Send:"+cmd.toXMLString()); // 送信内容
				
			}
		}
		
		public function cmd_onRecv(e:CommandEvent){
			write("Receive:"+e.command.toString());
			switch(e.command.name){
				case "zanmai":
					write("今年はざんまいに"+Base64.decode(e.command.value)+"回行く！");
					break;
				case "kazusuke":
					write("かず助にも"+Base64.decode(e.command.value)+"回行きたい");
					break;
				default:
					write("知らないコマンドが来た");
					break;
			}
		}
		
		public function cmd_ioError(e:IOErrorEvent) {
			write("IO Error:"+e.text);
		}
		
		public function cmd_securityError(e:SecurityError) {
			write("Security Error:"+e.message);
		}
		
		public function cmd_onConnect(e:Event){
			write("Connect!");
		}
		
		public function write(str:String){
			textAreaLog.text = str + "\n" + textAreaLog.text;
			trace(str);
		}		
	}
}